﻿import { CellsysType } from './cellsysUtil.js'
import CellsysElement from './cellsysElement.js'
import {hexColorToRgba} from "@/utils/utils";

class CellsysOfflinePolygon extends CellsysElement {
    constructor(params) {

        if (!params) {
            params = {}
        }
        super(params)
        this.cellsysType = CellsysType.OfflinePolygon
        this.id = params.id
        this.name = params.name
        this.type = params.type
        this.status = params.status ? params.status : 1
        this.action = params.action
        this.bufferDistance = params.buffer_distance || 0
        this.geometry = params.geometry
        this.typeName = params.type_name
        this.orgId = params.org_id
        this.orgName = params.org_name
        this.description = params.description
        this.style = params.style
        this.isTile = params.is_tile ? params.is_tile : 0
    }

    setId(value) {
        this.id = value
    }

    setName(name) {
        this.name = name
    }

    setType(type) {
        this.type = type
    }

    setAction(value) {
        this.action = value
    }

    setBufferDistance(value) {
        this.bufferDistance = value
    }

    setDescription(value) {
        this.description = value
    }

    setGeometry(value) {
        this.geometry = value
    }

    getColor() {
        return this.style ? this.style.color : '#000000'
    }

    getFillColor() {
        return this.style ? this.style.fillColor : null
    }

    getCssStyle() {
        // return formatterPolygonStyle(this.style)
        if (this.style) {
            let strokeOpacity = this.style.strokeOpacity;
            strokeOpacity = strokeOpacity === null || strokeOpacity === undefined ? 0 : strokeOpacity;
            let colors = hexColorToRgba(this.style.strokeColor || '#000000');
            colors.push(strokeOpacity);
            let border = this.style.weight + 'px ' + 'solid rgba(' + colors.join(',') + ')';

            let fillOpacity = this.style.fillOpacity;
            fillOpacity = fillOpacity === null || fillOpacity === undefined ? 0 : fillOpacity;
            let colors2 = hexColorToRgba(this.style.fillColor || '#000000');
            colors2.push(fillOpacity);
            let backgroundColor = 'rgba(' + colors2.join(',') + ')';
            return {
                border: border,
                'background-color': backgroundColor,
                cursor: 'text',
            };
        }
        return null;
    }
}


export default CellsysOfflinePolygon
